@echo off

rem *************************************************** 
rem *                                                 *
rem * Decode front end control program                *
rem *                                                 *
rem *************************************************** 

  set version=1.2
  set l2=2
  set l3=2
  set net=network_etsi
  set dsl=0
  set filein=
  set fileout=decode.txt
  set cref=0
  set summary=1
  set detail=1
  set NT=2
:parse
  if .%1.==.. goto start
:skip
  if %1==l2_off    set l2=0
  if %1==l2_hex    set l2=1
  if %1==l3_off    set l3=0
  if %1==l3_hex    set l3=1
  if %1==dms       set net=network_dms
  if %1==etsi      set net=network_etsi
  if %1==att       set net=network_att
  if %1==ni2       set net=network_ni2
  if %1==dss1      set net=network_dss1
  if %1==qsig      set net=network_qsig
  if %1==dsl1      set dsl=1
  if %1==dsl2      set dsl=2
  if %1==dsl3      set dsl=3
  if %1==dsl4      set dsl=4
  if %1==nodetail  set detail=0
  if %1==nosummary set summary=0
  if %1==TE        set NT=0
  if %1==NT        set NT=1
  if %1==cref      goto dcref
  if %1==in        goto fin
  if %1==out       goto fout
:resume
  shift
  goto parse

:dcref
  shift
  set cref=%1
  goto resume

:fin
  shift
  set filein=%1
  goto resume

:fout
  shift
  set fileout=%1
  goto resume

:start
  echo ------- TRACE DECODER VERSION %version% IN:%filein% OUT:%fileout% -------
  if .%filein%.==.. goto help
  if .%fileout%.==.. goto help
  if %filein%==%fileout% goto help

  if %summary%==0 goto sumdone
  echo ***************** L3 SUMMARY DECODE (%filein%) **************** >%fileout%
  if not %cref%==0 echo ***************** CALL REFERENCE (%cref%) >>%fileout%
  echo. >>%fileout%
  echo ... l3 summary decode output
  decode c:\tools\decode\decode.dec %filein% decode_lyr2=%l2%,decode_lyr3=%l3%,%net%=1,lyr3_summary=1,dsl=%dsl%,cref=%cref%,is_nt=%NT% >>%fileout%
  echo. >>%fileout%

:sumdone
  if %detail%==0 goto decdone
  echo ***************** DETAIL DECODE (%filein%) ***************** >>%fileout%
  if not %cref%==0 echo ***************** CALL REFERENCE (%cref%) >>%fileout%
  echo. >>%fileout%
  echo ... l3 detail decode output
  decode c:\tools\decode\decode.dec %filein% decode_lyr2=%l2%,decode_lyr3=%l3%,%net%=1,echo=0,dsl=%dsl%,cref=%cref%,is_nt=%NT% >>%fileout%

:decdone
  echo ------------------------ FINISHED --------------------------
  goto end

:help
  echo.
  echo usage: dec [sum] [l2] [l3] [TE/NT] [net] [dsl] [cref callref] in filein [out fileout]
  echo.
  echo where:
  echo     sum = nodetail for summary only (no detail)
  echo           nosummary for detail only (no summary)
  echo.
  echo     l2  = l2_off  no l2 decode
  echo           l2_hex  for l2 hex decode
  echo           l2_full for l2 full decode
  echo.
  echo     l3  = l3_off  no l3 decode
  echo           l3_hex  for l3 hex decode
  echo           l3_full for l3 full decode
  echo.
  echo     net = dms,etsi,att,ni2,qsig,dss1
  echo     dsl = dsl1,dsl2,dsl3,dsl4
  echo   TE/NT = TE,NT (if known)
  echo.
  echo  filein = trace input file
  echo  fileout= trace output decode file
  echo.
  echo  default is:
  echo     l2/l3 full decode, etsi, all DSLs, summary and detail, all cr's,
  echo     default output file is decode.txt
  echo.
  echo  TRACE FILES:
  echo    Pre-R5:
  echo       filein extension = ".old"
  echo       debug enable _TN i
  echo       debug on
  echo.
  echo    R5 onwards:
  echo       filein extension = anything other than ".old"
  echo       debug enable _ISDN *RawRx,RawTx
  echo       debug on
  echo.
  goto end

:end
